VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6450
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10410
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6450
   ScaleWidth      =   10410
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame3 
      Caption         =   "Adapter info"
      Height          =   3015
      Left            =   5880
      TabIndex        =   4
      Top             =   0
      Width           =   4455
      Begin MSComctlLib.ListView lvAdapter 
         Height          =   2655
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Width           =   4215
         _ExtentX        =   7435
         _ExtentY        =   4683
         View            =   3
         LabelEdit       =   1
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         FullRowSelect   =   -1  'True
         GridLines       =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   0
         NumItems        =   2
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Name"
            Object.Width           =   3704
         EndProperty
         BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   1
            Text            =   "Value"
            Object.Width           =   3704
         EndProperty
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Media info"
      Height          =   3255
      Left            =   5880
      TabIndex        =   2
      Top             =   3120
      Width           =   4455
      Begin MSComctlLib.ListView lvMedia 
         Height          =   2895
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   4215
         _ExtentX        =   7435
         _ExtentY        =   5106
         View            =   3
         LabelEdit       =   1
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         FullRowSelect   =   -1  'True
         GridLines       =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   0
         NumItems        =   2
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Name"
            Object.Width           =   3175
         EndProperty
         BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   1
            Text            =   "Value"
            Object.Width           =   3704
         EndProperty
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Device info"
      Height          =   5895
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   5655
      Begin MSComctlLib.ListView lvDevice 
         Height          =   5415
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   5415
         _ExtentX        =   9551
         _ExtentY        =   9551
         View            =   3
         LabelEdit       =   1
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         FullRowSelect   =   -1  'True
         GridLines       =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   0
         NumItems        =   2
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Name"
            Object.Width           =   3351
         EndProperty
         BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   1
            Text            =   "Value"
            Object.Width           =   5662
         EndProperty
      End
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   120
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   120
      Width           =   5655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Combo1_Click()
   Dim idx As Long
   idx = Combo1.ListIndex
   If GetCDInfo(cdi_short(idx).DriveLetter) = False Then Exit Sub
   ShowDeviceInfo idx
   ShowAdapterInfo
   ShowMediaInfo
End Sub

Private Sub Form_Load()
   Dim i As Long
   EnumCDDrives
   For i = 0 To UBound(cdi_short)
      With cdi_short(i)
         Combo1.AddItem .DriveLetter & ": [" & .FriendlyName & "]"
         Combo1.ItemData(Combo1.NewIndex) = .DeviceID
      End With
   Next i
   If Combo1.ListCount = 0 Then
      Combo1.AddItem "No CD found!"
      Combo1.Enabled = False
   Else
      Combo1.ListIndex = 0
   End If
End Sub

Private Sub ShowAdapterInfo()
   lvAdapter.ListItems.Clear
   With cdi.ai
      lvAdapter.ListItems.Add(, , "Bus type").SubItems(1) = .BusType
      lvAdapter.ListItems.Add(, , "   Major version").SubItems(1) = "0x" & Hex(.BusMajorVersion)
      lvAdapter.ListItems.Add(, , "   Minor version").SubItems(1) = "0x" & Hex(.BusMinorVersion)
      lvAdapter.ListItems.Add(, , "Max. Physical Pages").SubItems(1) = "0x" & Hex(.MaximumPhysicalPages)
      lvAdapter.ListItems.Add(, , "Max. Transfer Length").SubItems(1) = "0x" & Hex(.MaximumTransferLength)
      lvAdapter.ListItems.Add(, , "Alignment Mask").SubItems(1) = TranslateAdapterAlignmentMask(.AlignmentMask)
      lvAdapter.ListItems.Add(, , "Futures:").ForeColor = vbBlue
      lvAdapter.ListItems.Add(, , "   Accelerated Transfer").SubItems(1) = YesNoBoolean(.AcceleratedTransfer)
      lvAdapter.ListItems.Add(, , "   Adapter Scans Down").SubItems(1) = YesNoBoolean(.AdapterScansDown)
      lvAdapter.ListItems.Add(, , "   Adapter Uses Pio").SubItems(1) = YesNoBoolean(.AdapterUsesPio)
      lvAdapter.ListItems.Add(, , "   Command Queueing").SubItems(1) = YesNoBoolean(.CommandQueueing)
      
   End With
End Sub

Private Sub ShowDeviceInfo(ByVal idx As Long)
   Dim i As Long
   Dim s As String, s1 As String
   Dim li As ListItem
   
   lvDevice.ListItems.Clear
   i = cdi_short(idx).DeviceID
   s = "CdRom #" & i & " (\Device\CdRoom" & i & ")"
   lvDevice.ListItems.Add(, , "Device").SubItems(1) = s
   With cdi.di
      If .DeviceType = 0 Then .DeviceType = cdi_short(idx).DeviceType
      If .DeviceType Then s = TranslateDeviceType(.DeviceType) Else s = "CD-ROM"
      lvDevice.ListItems.Add(, , "Device type").SubItems(1) = s
      s = UCase(.BusType)
      With .DeviceAddress
         Select Case s
            Case "SCSI"
                 s = s & " (Bus Number " & .PathId & ", Target ID " & .TargetId & ", LUN " & .Lun
            Case "ATI", "ATAPI"
                 s = s & " (IDE_" & .PortNumber & IIf(.TargetId, ", Slave", ", Master")
            Case Else
                 s = s & " (Port number: " & .PortNumber & ", Path ID " & .PathId & ", Target ID " & .TargetId & ", LUN " & .Lun
         End Select
      End With
      s = s & ")"
      lvDevice.ListItems.Add(, , "Bus type").SubItems(1) = s
      lvDevice.ListItems.Add(, , "Vendor").SubItems(1) = .VendorName
      lvDevice.ListItems.Add(, , "Product ID").SubItems(1) = .ProductID
      lvDevice.ListItems.Add(, , "Product Rev").SubItems(1) = .ProductRev
      If .SerialNumber <> "" Then
          lvDevice.ListItems.Add(, , "Serial No.").SubItems(1) = UCase(.SerialNumber)
      Else
          lvDevice.ListItems.Add(, , "Serial No.").SubItems(1) = "Not available"
      End If
      lvDevice.ListItems.Add(, , "Volume levels supported").SubItems(1) = .VolumeLevels
      lvDevice.ListItems.Add(, , "Buffer size supported").SubItems(1) = .BufferSize & " kBytes"
      lvDevice.ListItems.Add(, , "Copy management").SubItems(1) = YesNoBoolean(.CopyManagement)
      With .Capabilities
           Set li = lvDevice.ListItems.Add(, , "Read capabilities:")
           li.ForeColor = vbBlue
           s = ""
           s = s & IIf(.CD_R_Read, "CD_R, ", "")
           s = s & IIf(.CD_RW_Read, "CD_RW, ", "")
           s = s & IIf(.Method2_Read, "Method 2, ", "")
           If s <> "" Then s = Left(s, Len(s) - 2)
           s1 = s
           s = ""
           s = s & IIf(.DVD_ROM_Read, "DVD_ROM, ", "")
           s = s & IIf(.DVD_R_Read, "DVD_R, ", "")
           s = s & IIf(.DVD_RAM_Read, "DVD_RAM, ", "")
           If s <> "" Then s = Left(s, Len(s) - 2)
           If s1 = "" And s = "" Then
              li.SubItems(1) = "None"
           Else
              lvDevice.ListItems.Add(, , "   CD").SubItems(1) = IIf(s1 <> "", s1, "None")
              lvDevice.ListItems.Add(, , "   DVD").SubItems(1) = IIf(s <> "", s, "None")
              With cdi.di
                 s1 = .MaxReadSpeed & " kB/sec. (CD " & TranslateCDSpeed(.MaxReadSpeed)
                 If s <> "" Then s1 = s1 & ", DVD " & TranslateCDSpeed(.MaxReadSpeed / 8)
                 s1 = s1 & ")"
                 lvDevice.ListItems.Add(, , "   Maximum speed").SubItems(1) = s1
                 s1 = .CurReadSpeed & " kB/sec. (CD " & TranslateCDSpeed(.CurReadSpeed)
                 If s <> "" Then s1 = s1 & ", DVD " & TranslateCDSpeed(.CurReadSpeed / 8)
                 s1 = s1 & ")"
                 lvDevice.ListItems.Add(, , "   Current speed").SubItems(1) = s1
              End With
           End If
           Set li = lvDevice.ListItems.Add(, , "Write capabilities:")
           li.ForeColor = vbBlue
           s = ""
           s = s & IIf(.CD_R_Write, "CD_R, ", "")
           s = s & IIf(.CD_RW_Write, "CD_RW, ", "")
           s = s & IIf(.Test_Write, "Test write, ", "")
           If s <> "" Then s = Left(s, Len(s) - 2)
           s1 = s
           s = ""
           s = s & IIf(.DVD_R_Write, "DVD_R, ", "")
           s = s & IIf(.DVD_RAM_Write, "DVD_RAM, ", "")
           If s <> "" Then s = Left(s, Len(s) - 2)
           If s = "" And s1 = "" Then
              li.SubItems(1) = "None"
           Else
              lvDevice.ListItems.Add(, , "   CD").SubItems(1) = IIf(s1 <> "", s1, "None")
              lvDevice.ListItems.Add(, , "   DVD").SubItems(1) = IIf(s <> "", s, "None")
              With cdi.di
                   s1 = .MaxWriteSpeed & " kB/sec. (CD " & TranslateCDSpeed(.MaxWriteSpeed)
                   If s <> "" Then s1 = s1 & ", DVD " & TranslateCDSpeed(.MaxWriteSpeed / 8)
                   s1 = s1 & ")"
                   lvDevice.ListItems.Add(, , "   Maximum speed").SubItems(1) = s1
                   s1 = .CurWriteSpeed & " kB/sec. (CD " & TranslateCDSpeed(.CurWriteSpeed)
                   If s <> "" Then s1 = s1 & ", DVD " & TranslateCDSpeed(.CurWriteSpeed / 8)
                   s1 = s1 & ")"
                   lvDevice.ListItems.Add(, , "   Current speed").SubItems(1) = s1
                   If .numWPD Then
                       s = ""
                       For i = 1 To .numWPD
                           s = s & TranslateCDSpeed(.WPD(i).WriteSpeedSupported) & ", "
                       Next i
                       If s <> "" Then lvDevice.ListItems.Add(, , "   Steps").SubItems(1) = Left(s, Len(s) - 2)
                   End If
              End With
           End If
           lvDevice.ListItems.Add(, , "Play capabilities:").ForeColor = vbBlue
           lvDevice.ListItems.Add(, , "   Play audio").SubItems(1) = YesNoBoolean(.AudioPlay)
           lvDevice.ListItems.Add(, , "   Play composite").SubItems(1) = YesNoBoolean(.Composite)
           lvDevice.ListItems.Add(, , "   Digital on port 1").SubItems(1) = YesNoBoolean(.DigitalPort1)
           lvDevice.ListItems.Add(, , "   Digital on port 2").SubItems(1) = YesNoBoolean(.DigitalPort2)
           lvDevice.ListItems.Add(, , "   Mode 2 Form 1").SubItems(1) = YesNoBoolean(.Mode2Form1)
           lvDevice.ListItems.Add(, , "   Mode 2 Form 2").SubItems(1) = YesNoBoolean(.Mode2Form2)
           lvDevice.ListItems.Add(, , "   Multi session").SubItems(1) = YesNoBoolean(.MultiSession)
           lvDevice.ListItems.Add(, , "   BUF under-run free").SubItems(1) = YesNoBoolean(.BUF_Under_Run_Free)
           lvDevice.ListItems.Add(, , "   CDDA support").SubItems(1) = YesNoBoolean(.CDDA)
           lvDevice.ListItems.Add(, , "   CDDA accurate").SubItems(1) = YesNoBoolean(.CDDA_Accurate)
           lvDevice.ListItems.Add(, , "   R/W support").SubItems(1) = YesNoBoolean(.R_W_Supported)
           lvDevice.ListItems.Add(, , "   R/W Deinterleaved").SubItems(1) = YesNoBoolean(.R_W_Deinterleaved)
           lvDevice.ListItems.Add(, , "   C2 pointers").SubItems(1) = YesNoBoolean(.C2_Pointers)
           lvDevice.ListItems.Add(, , "   ISRC").SubItems(1) = YesNoBoolean(.ISRC)
           lvDevice.ListItems.Add(, , "   UPC").SubItems(1) = YesNoBoolean(.UPC)
           lvDevice.ListItems.Add(, , "   Read bar code").SubItems(1) = YesNoBoolean(.Read_Bar_Code)
           lvDevice.ListItems.Add(, , "Load/Unload capabilities:").ForeColor = vbBlue
           lvDevice.ListItems.Add(, , "   Lock support").SubItems(1) = YesNoBoolean(.Lock)
           lvDevice.ListItems.Add(, , "   Lock state").SubItems(1) = IIf(.LockState, "Locked", "Unlocked")
           lvDevice.ListItems.Add(, , "   Prevent Jumper").SubItems(1) = YesNoBoolean(.PreventJumper)
           lvDevice.ListItems.Add(, , "   Auto eject").SubItems(1) = YesNoBoolean(.Eject)
           lvDevice.ListItems.Add(, , "   Loading mech. type").SubItems(1) = TranslateLoadingMech(.LoadingMechType)
           If .LoadingMechType > 3 Then
               lvDevice.ListItems.Add(, , "Changer capabilities:").ForeColor = vbBlue
               lvDevice.ListItems.Add(, , "   Separate Vol. level").SubItems(1) = YesNoBoolean(.SeparateVolumeLevel)
               lvDevice.ListItems.Add(, , "   Separate Chan. mute").SubItems(1) = YesNoBoolean(.SeparateChannelMute)
               lvDevice.ListItems.Add(, , "   Support disk present").SubItems(1) = YesNoBoolean(.SupportDiskPresent)
               lvDevice.ListItems.Add(, , "   SW slot selection").SubItems(1) = YesNoBoolean(.SW_SlotSelection)
               lvDevice.ListItems.Add(, , "   Side change capable").SubItems(1) = YesNoBoolean(.SideChangeCapable)
               lvDevice.ListItems.Add(, , "   R/W Lead In").SubItems(1) = YesNoBoolean(.RW_In_LeadIn)
           End If
       End With
       With .DOF
          lvDevice.ListItems.Add(, , "Digital output capabilities:").ForeColor = vbBlue
          lvDevice.ListItems.Add(, , "   BCKF").SubItems(1) = YesNoBoolean(.BCKF)
          lvDevice.ListItems.Add(, , "   RCK").SubItems(1) = YesNoBoolean(.RCK)
          lvDevice.ListItems.Add(, , "   LSBF").SubItems(1) = YesNoBoolean(.LSBF)
          lvDevice.ListItems.Add(, , "   World length").SubItems(1) = .WordLength
       End With
   End With
End Sub

Private Sub ShowMediaInfo()
   Dim s As String
   Dim dblTemp As Double
   Dim li As ListItem
   Caption = "CD info"
   lvMedia.ListItems.Clear
   With cdi.mi
      If Not .Present Then
         lvMedia.ListItems.Add(, , "No media").Bold = True
         Exit Sub
      End If
      lvMedia.ListItems.Add(, , "Media type").SubItems(1) = .MediaType
      lvMedia.ListItems.Add(, , "Disk type").SubItems(1) = .DiskType
      Set li = lvMedia.ListItems.Add(, , "Formatted")
      li.SubItems(1) = YesNoBoolean(.Formatted)
      If Not .Formatted Then
         li.Bold = True
         li.ForeColor = vbRed
      End If
      lvMedia.ListItems.Add(, , "Volume Label").SubItems(1) = .VolumeLabel
      lvMedia.ListItems.Add(, , "Serial Number").SubItems(1) = .VolumeSerial
      lvMedia.ListItems.Add(, , "File System").SubItems(1) = .FileSystem
      lvMedia.ListItems.Add(, , "Cylinders").SubItems(1) = .Cylinders * 10000
      lvMedia.ListItems.Add(, , "Tracks Per Cylinder").SubItems(1) = .TracksPerCylinder
      lvMedia.ListItems.Add(, , "Sectors Per Track").SubItems(1) = .SectorsPerTrack
      lvMedia.ListItems.Add(, , "Bytes Per Sector").SubItems(1) = .BytesPerSector
      lvMedia.ListItems.Add(, , "Media Sides").SubItems(1) = .MediaSides
      lvMedia.ListItems.Add(, , "Total size  (hh:mm:ss.ff)").SubItems(1) = HMSFToString(DoubleToHMSF(.BytesTotal / .BytesPerSector)) & " (" & FormatByteSize(.BytesTotal) & ")"
      lvMedia.ListItems.Add(, , "Used area (hh:mm:ss.ff)").SubItems(1) = HMSFToString(DoubleToHMSF(.BytesInUse / .BytesPerSector)) & " (" & FormatByteSize(.BytesInUse) & ")"
      lvMedia.ListItems.Add(, , "Capacity    (hh:mm:ss.ff)").SubItems(1) = HMSFToString(DoubleToHMSF(.Capacity / .BytesPerSector)) & " (" & FormatByteSize(.Capacity) & ")"
      lvMedia.ListItems.Add(, , "Free           (hh:mm:ss.ff)").SubItems(1) = HMSFToString(DoubleToHMSF(.BytesFree / .BytesPerSector)) & " (" & FormatByteSize(.BytesFree) & ")"
      lvMedia.ListItems.Add(, , "Available   (hh:mm:ss.ff)").SubItems(1) = HMSFToString(DoubleToHMSF(.BytesAvailable / .BytesPerSector)) & " (" & FormatByteSize(.BytesAvailable) & ")"
      lvMedia.ListItems.Add(, , "Disk status").SubItems(1) = .DiskStatus
      lvMedia.ListItems.Add(, , "Last session status").SubItems(1) = .LastSessionStatus
      lvMedia.ListItems.Add(, , "Sessions").SubItems(1) = .NumberOfSessions
      lvMedia.ListItems.Add(, , "Tracks").SubItems(1) = .LastSessionLastTrack - .FirstTrackNumber + 1
'      If .Characteristics Then
'         lvMedia.ListItems.Add(, , "Characteristics").ForeColor = vbBlue
'         lvMedia.ListItems.Add(, , "   Eraseable").SubItems(1) = YesNoBoolean(.Characteristics And MEDIA_ERASEABLE)
'        lvMedia.ListItems.Add(, , "   Write once").SubItems(1) = YesNoBoolean(.Characteristics And MEDIA_WRITE_ONCE)
'         lvMedia.ListItems.Add(, , "   Read only").SubItems(1) = YesNoBoolean(.Characteristics And MEDIA_READ_ONLY)
'         lvMedia.ListItems.Add(, , "   Read write").SubItems(1) = YesNoBoolean(.Characteristics And MEDIA_READ_WRITE)
'         lvMedia.ListItems.Add(, , "   Write protected").SubItems(1) = YesNoBoolean(.Characteristics And MEDIA_WRITE_PROTECTED)
'        lvMedia.ListItems.Add(, , "   Currently mounted").SubItems(1) = YesNoBoolean(.Characteristics And MEDIA_CURRENTLY_MOUNTED)
'      End If
   End With
End Sub
